#ifndef sigma_Args_INCLUDED
#define sigma_Args_INCLUDED

#include <vector>
#include <deque>

#include <ptr/Type.hpp>
#include <ptr/Ptr.hpp>

namespace sigma {

struct Args : std::deque<Ptr<Anything> > {};
struct Types : std::vector<Type> {};

Types getTypes(const Args&);

struct Form {
  Form(const Type& r, const Types& a) : return_type(r), arg_types(a) {}
  Type return_type;
  Types arg_types;
};


struct Forms : std::vector<Form> {};

namespace cell_detail {

template <>
struct TypedPackage<Args> : TypedPackageBase<Args> {

  explicit TypedPackage(Args* ptr) :
    TypedPackageBase<Args>(ptr) {}

  virtual bool contains(Cell const * const that_cell) const {
    Args* args = reinterpret_cast<Args*>(ptr);
    for (Args::const_iterator i=args->begin();
	 i!=args->end();
	 ++i) {

      Cell const * const this_cell = &(*i);
      if (that_cell==this_cell) return true;
    }
    return false;
  }
};

} // end namespace cell_detail

} // end namespace sigma


#endif
