#include "Method.hpp"

namespace sigma {

Types Method::getArgTypes() const {

  Types types;
  for (unsigned int i=0; i<arity(); ++i) {
    Type type = argType(i);
    types.push_back(type);
  }
  return types;
}

void Method::checkTypes(const Args& args) const {

  if (args.size()!=arity()) {
    throw NoMatch(getArgTypes(), getTypes(args));
  }

  unsigned int i = 0;
  for (Args::const_iterator j = args.begin();
       j != args.end();
       ++j) {

    if (!isa((*j).type(), argType(i++))) {
      throw NoMatch(getArgTypes(), getTypes(args));
    }
  }

}


} // end namespace sigma
