#ifndef sigma_Method_INCLUDED
#define sigma_Method_INCLUDED

#include <ptr/Type.hpp>
#include <ptr/Ptr.hpp>
#include <generic/Args.hpp>
#include <generic/Function.hpp>

namespace sigma {

struct Method : Function {

  // thrown by checkTypes
  struct NoMatch {
    NoMatch(const Types& e, const Types& f) : expected(e), found(f) {}
    Types expected;
    Types found;
  };

  virtual unsigned int arity() const = 0;
  virtual Type returnType() const = 0;
  virtual Type argType(unsigned int) const = 0;

  Types getArgTypes() const;

  void checkTypes(const Args&) const;

  // bool check type
};

namespace {
DeclareTypeName<Method> method_type_name("method");
DeclareSubtypeConverter<Method,Function> method_function_type_converter;
}

} // end namespace sigma

#endif
