#include "Init.hpp"

#include <assert.h>

namespace sigma {


Init::CountMap* Init::count_map = 0;


Init::Init(FuncPtr fp) {

  if (count_map==0) count_map = new CountMap();

  assert(count_map);
  iterator = count_map->find(fp);
  if (iterator==count_map->end()) {
    (*fp)(true);
    std::pair<CountMap::iterator,bool> result 
      = count_map->insert(std::make_pair(fp,1));
    assert(result.second);
    iterator = result.first;
  } else {
    ++(*iterator).second;
  }
}

Init::~Init() {

  assert(count_map);

  int& count = (*iterator).second;
  --count;
  if (0 == count) {
    FuncPtr fp = (*iterator).first;
    (*fp)(false);
    count_map->erase(iterator);
  }

  if (count_map->empty()) delete count_map;
}


} // end namespace sigma
