#ifndef sigma_Pos_INCLUDED
#define sigma_Pos_INCLUDED

#include <set>

namespace sigma {

namespace dfa_detail {

template <typename Letter>
struct Pos {

  Pos(Letter l, int n) : letter(l), number(n) {}

  Letter letter;
  int number;
};


template <typename Letter>
bool operator<(Pos<Letter> a, Pos<Letter> b) {
  return a.number < b.number;
}


template <typename Letter>
struct MakePos {

  MakePos() : count(0) {}

  Pos<Letter> operator()(Letter letter) {

    return Pos<Letter>(letter, ++count);

  }

  int count;
};


template <typename Letter>
struct PosSet : std::set<Pos<Letter> > {};

template <typename Letter>
bool operator<(const PosSet<Letter>& a, const PosSet<Letter>& b) {
  return std::lexicographical_compare(a.begin(), a.end(),
				      b.begin(), b.end());
}

} // end namespace dfa_detail

} // end namespace sigma

#endif
