#ifndef sigma_parse_Dstate_INCLUDED
#define sigma_parse_Dstate_INCLUDED

#include <parse/Item.hpp>

#include <map>

namespace sigma {

namespace parse_detail {

template <typename Context>
struct MakeDstate {

  typedef typename Item<Context>::ItemSet ItemSet;
  typedef typename std::map<ItemSet,size_t> ItemSets;
  typedef typename ItemSets::const_iterator Dstate;

  // The bool indicates whether the Dstate returned is new.

  std::pair<Dstate,bool> operator()(const ItemSet& ps) {

    typename ItemSets::const_iterator i = item_sets.find(ps);
    if (i != item_sets.end()) {
      return std::pair<Dstate,bool>(i,false);
    }

    return item_sets.insert(std::make_pair(ps,item_sets.size()));
  }

  ItemSets item_sets;

  const ItemSets& getItemSets() const {return item_sets;}
};


template <typename Context>
inline bool operator<(typename MakeDstate<Context>::Dstate a, 
		      typename MakeDstate<Context>::Dstate b) {
  return ((*a).second < (*b).second);
}

} // end namespace parse_detail

} // end namespace sigma

#endif
