#ifndef sigma_Cons_INCLUDED
#define sigma_Cons_INCLUDED

#include <utility>

#include <init/Init.hpp>
#include <ptr/Type.hpp>
#include <ptr/Ptr.hpp>

namespace sigma {

struct Nil {};

typedef std::pair<Ptr<Anything>,Ptr<Anything> > Cons;

Ptr<Cons> pr(const Ptr<Anything>&, const Ptr<Anything>&);
Ptr<Anything> hd(const Ptr<Cons>&);
Ptr<Anything> tl(const Ptr<Cons>&);
Ptr<bool> nil(const Ptr<Anything>&);

namespace {

DeclareTypeName<Cons> cons_type_name("pair");
DeclareTypeName<Nil> nil_type_name("nil");

} // end namespace

void initCons(bool);
namespace {Init cons_init(&initCons);}

} // end namespace sigma

#endif
