#include "Exp.hpp"

#include <sigma/env.hpp>
#include <sigma/resolve.hpp>
#include <sigma/eval.hpp>

namespace sigma {

unsigned int Exp::arity() const {return 1;}

Type Exp::returnType() const {return Type(typeid(Anything));}

Type Exp::argType(unsigned int i) const {
  if (i==0) return Type(typeid(SigmaEnv));
  return Type(typeid(Nothing));
}


Ptr<Anything> Exp::apply(const Args& args) const {

  checkTypes(args);

#if DEBUG
  Ptr<Anything> raw_env = args.front();
  Ptr<SigmaEnv> env = raw_env;
  Ptr<Anything> resolved_exp = resolve(env, exp);
#else
  Ptr<Anything> resolved_exp = resolve(args.front(), exp);
#endif

  Ptr<SigmaEnv> stack = make_sigma_env();
  Ptr<Anything> value = eval(stack, resolved_exp);
  return value;
}


} // end namespace sigma
