#ifndef sigma_Exp_INCLUDED
#define sigma_Exp_INCLUDED

#include <ptr/Type.hpp>
#include <ptr/Ptr.hpp>
#include <generic/Method.hpp>

namespace sigma {

struct Exp : Method {

  Exp(const Ptr<Anything>& e) : exp(e) {}

  virtual unsigned int arity() const;	// always 1
  virtual Type returnType() const; 	// always Anything
  virtual Type argType(unsigned int) const; // env for arg 0

  virtual Ptr<Anything> apply(const Args&) const;

  Ptr<Anything> exp;
};


namespace {
DeclareTypeName<Exp> exp_type_name("exp");
DeclareSubtypeConverter<Exp,Method> exp_method_type_converter;
}

} // end namespace sigma

#endif
