#include "Lambda.hpp"

#include <sigma/env.hpp>
#include <sigma/eval.hpp>

namespace sigma {

unsigned int Lambda::arity() const {return formals->size();}

Type Lambda::returnType() const {return Type(typeid(Anything));}

Type Lambda::argType(unsigned int i) const {
  if (i>=formals->size()) return Type(typeid(Nothing));
  return (*formals)[i].type;
}

Ptr<Anything> Lambda::apply(const Args& args) const {

  checkTypes(args);

  Ptr<SigmaEnv> env = make_sigma_env();
  Args::const_iterator i = args.begin();
  Formals::const_iterator j = formals->begin();

  while (i!=args.end()) {
    assert(j!=formals->end());
    env = extend(env, (*j++).symbol, *i++);
  }

  return eval(env, body);
}


} // end namespace sigma
