#include "env.hpp"

namespace sigma {

namespace {

Ptr<SigmaEnv>* the_env_ptr;

}


Ptr<SigmaEnv>& theEnv() {

  if (!the_env_ptr) {
    the_env_ptr = new Ptr<SigmaEnv>(new SigmaEnv(Symbol(),Ptr<Nothing>()));
  }

  return *the_env_ptr;
}


Ptr<Generic> getGeneric(Symbol s) {

  Ptr<Generic> generic = exists(theEnv(), s, Ptr<Nothing>());
  if (null(generic)) {
    generic = new Generic(s.name());
    theEnv() = extend(theEnv(), s, Ptr<Anything>(generic));
  }
  return generic;
}

} // end namespace sigma
