#include "extend.hpp"

#include <sigma/env.hpp>
#include <generic/Primitive.hpp>
#include <generic/Generic.hpp>
#include <generic/Method.hpp>


namespace sigma {

namespace {

Ptr<Generic> extendMethodMethod(const Ptr<Method>& a, 
				const Ptr<Method>& b) {

  Ptr<Generic> generic = new Generic();
  generic->bind(a);
  generic->bind(b);

  return generic;
}

Ptr<Generic> extendGenericMethod(const Ptr<Generic>& g, 
				 const Ptr<Method>& m) {

  Ptr<Generic> generic = new Generic(copy(*g));
  generic->bind(m);

  return generic;
}

Ptr<Generic> extendMethodGeneric(const Ptr<Method>& m,
				 const Ptr<Generic>& g) {

  Ptr<Generic> generic = new Generic(copy(*g));
  generic->bind(m);

  return generic;
}


} // end namespace


void initExtend(bool init) {

  if (init) {

    Ptr<Generic> extend = getGeneric("extend");

    extend->bind(primitive(&extendMethodMethod));
    extend->bind(primitive(&extendGenericMethod));
    extend->bind(primitive(&extendMethodGeneric));
  }
}

} // end namespace sigma
