#ifndef sigma_print_INCLUDED
#define sigma_print_INCLUDED

#include <iosfwd>

#include <generic/Generic.hpp>

/*
  Supported forms:

  (OutPort,bool) -> OutPort
  (OutPort,std::string) -> OutPort
  (OutPort,double) -> OutPort
  (OutPort,Rational) -> OutPort
  (OutPort,Integer) -> OutPort
  (OutPort,Natural) -> OutPort
  (OutPort,Cons) -> OutPort
  (OutPort,Nothing) -> OutPort
  (OutPort,Anything) -> OutPort

  (Anything) -> Nothing
*/

namespace sigma {

struct OutPort {

  // Default constructor defaults to cout.

  OutPort();

  mutable std::ostream* out;
};


template <typename T>
Ptr<OutPort> operator<<(const Ptr<OutPort>& out, const T& item) {
  *(out->out) << item;
  return out;
}


Ptr<OutPort> operator<<(const Ptr<OutPort>&, const Ptr<Anything>&);



} // end namespace sigma

#endif
