#ifndef sigma_replace_INCLUDED
#define sigma_replace_INCLUDED

#include <generic/Generic.hpp>
#include <sigma/Lambda.hpp>

/*
  To allow for recursively defined functions, the replace function
  will destructively replace a symbol in the AST with the value
  provided in the binding.

  Supported forms:

  (RecLambda, Symbol) -> Anything
  (RecLambda, Block) -> Anything
  (RecLambda, Cons) -> Anything
  (RecLambda, Apply) -> Anything
  (RecLambda, Lambda) -> Anything
  (RecLambda, Anything) -> Anything
  (RecLambda, If) -> Anything

*/


namespace sigma {

struct RecLambda {

  RecLambda(Symbol n, const Ptr<Lambda>& l) : name(n), lambda(l) {}

  Symbol name;
  Ptr<Lambda> lambda;
};

extern Generic replace;

} // end namespace sigma


#endif
